(defun C:OffsetBothSides ()
  (changeSettings)
  
  (setq acadObject (vlax-get-acad-object))
  (setq acadDocument (vla-get-activedocument acadObject))
  (setq utility (vla-get-utility acadDocument))
  
  (while T
    (setq offsetDist (getvar "offsetdist"))
    (if (= offsetDist -1)
      (setq offsetDefaultValue "通過点")
      (setq offsetDefaultValue (rtos offsetDist 2))
    )
    
    (initget 6 "T")
    (setq offsetDistance (getreal (strcat "\nオフセット距離を指定 または [通過点(T)] <" offsetDefaultValue ">:")))
    
    (if (= offsetDistance nil)
      (setq offsetDistance offsetdist)
    )
    
    (if (= offsetDistance -1)
      (setq offsetDistance "T")
    )
    
    (vla-getentity utility 'vlaObject 'pickedPoint "\nオフセットするオブジェクトをを選択:")
    (setq pickedPoint (vlax-safearray->list pickedPoint))
    
    (command "_offset" offsetDistance (vlax-vla-object->ename vlaObject))

    (if (= offsetDistance "T")
      (progn
        (command pause)
      )
      (progn
        (command pickedPoint)
      )
    )
    
    (setq offsetpoint (getvar "lastpoint"))
    
    (setq closestPoint (vlax-curve-getClosestPointTo vlaObject offsetPoint T))

    (setq deltaX (- (nth 0 offsetPoint) (nth 0 closestPoint)))
    (setq deltaY (- (nth 1 offsetPoint) (nth 1 closestPoint)))

    (setq newOffsetPointX (- (nth 0 closestPoint) deltaX))
    (setq newOffsetPointY (- (nth 1 closestPoint) deltaY))
    (setq newOffsetPoint (list newOffsetPointX newOffsetPointY))
    
    (command (vlax-vla-object->ename vlaObject) newOffsetPoint "")
  )
  
  (restoreSettings)
  (princ)
)

(defun changeSettings ()
  (setq osmode_org (getvar "osmode"))
  (setq *error_org* *error*)
  (setq *error* *OffsetBothSidesError*)
  
  (setvar "osmode" 0)
)

(defun restoreSettings ()
  (setvar "osmode" osmode_org)
  (setq *error* *error_org*)
)

(defun *OffsetBothSidesError* (msg)
  (terpri)
  (princ msg)
  (restoreSettings)
  (princ)
)

(princ "\nコマンド名：OffsetBothSides")
(princ)
